#!/usr/bin/env jython
import sys
sys.path.append("/home/amit/SpatialRoleLabeling/SIdetection/stanford-parser-2008-10-26/stanford-parser.jar")  
from java.io import CharArrayReader
from edu.stanford.nlp import *
from edu.stanford.nlp.trees import TreePrint
from pprint import pprint
import cPickle
from xml.dom import minidom

#from tokenize import *
#from postagger import *

################################CONFIGURATION#################################
# pointer to Stanford Parser 
lp = parser.lexparser.LexicalizedParser("/home/amit/SpatialRoleLabeling/SIdetection/stanford-parser-2008-10-26/englishPCFG.ser.gz")
#lp.setOptionFlags(["-maxLength", "80", "-retainTmpSubcategories", "-outputFormat", "wordsAndTags,penn,typedDependenciesCollapsed"])

# Peen TreeBank language pack 
tlp = trees.PennTreebankLanguagePack()
lp.setOptionFlags(["-maxLength", "80", "-retainTmpSubcategories", "-outputFormat", "wordsAndTags,penn,typedDependenciesCollapsed", "-outputFormatOptions", "xml", "-writeOutputFiles"])

#lp.setOptionFlags(["-maxLength", "80", "-retainTmpSubcategories", "-outputFormat", "wordsAndTags,penn,typedDependencies" "-outputFormatOptions", "basicDependencies"])

dtprnt = TreePrint("typedDependencies", "basicDependencies,stem", tlp)

###############################PARSING########################################

#def my_parser(tokens):
doc = minidom.Document()
sentence = " They are goin on a book."
#print "\n \nSENTENCE :: ", sentence
tokens = sentence.split()
#print "\n \nTOKENIZED SENTENCE :: ", tokens
    #tw = []
    #for pair in tokens:
    #     tw.append([pair.split("/")[0], pair.split("/")[1]])
    #tokens = tw
    #print "tokens :: \n", tokens

if (lp.parse(tokens)):
    parse = lp.getBestParse()

    # Get tree and dependencies                                                             
gsf = tlp.grammaticalStructureFactory() #PennTreeBanck factory                          
gs = gsf.newGrammaticalStructure(parse) #PennTreeBank from parsed sentence               
tdl = gs.typedDependenciesCollapsed() #syntantic dependencies (TypeDependency list) 

tree = parse.toString()
#print "\nPARSED TREE :: ", tree
#print "\n \n PARSER OUTPUT \n"
dtprnt.printTree(parse)
f = open('tree.p', 'w')
f.write(tree)
f.close()
list = []

#print "\n \n \n"
depsnode = doc.createElement("DEPENDENCIES")
for td in tdl:
    #print "td to string: ", td.toString()
    deprelnode = doc.createElement('DEPREL')
    #print "LONG NAME*****", td.reln().getLongName()
    name = td.reln().getShortName()
    specific = td.reln().getSpecific()
    gov = td.gov().label().toString('value')
    dep = td.dep().label().toString('value')
    list.append({'name': name, 'specific': specific, 'gov': gov, 'dep': dep})
    #print name
    #print specific
    #print gov
    #print dep
    depreltext = doc.createTextNode('name:' + name + ' specific:' + str(specific) +\
				 ' gov:' + gov + ' dep:' + dep)
    #print "depreltext :::: \n", depreltext
    deprelnode.appendChild(depreltext)
    depsnode.appendChild(deprelnode)
    
doc.appendChild(depsnode)
        
f = open('dependencies.xml', 'wb')
#f.write(depreltext)
doc.writexml(f)
#cPickle.dump(list, f)
f.close()

#f = open('dependencies.xml', 'wb')
#cPickle.dump(list, open('dependencies.p', 'wb')) 
#f.close()

        #deprelnode.appendChild(depreltext)
        #depsnode.appendChild(deprelnode)
    #content.parentNode.appendChild(depsnode)
